/*++

Copyright (c) Sydus.

Module:

    ClientSocket.h

Authors:

    Sharvil Nanavati (sharvil) 2006-07-30

--*/

#pragma once

#include "base.h"
#include "Socket.h"

class ClientSocket : public Socket
{
	public:
		void Connect(const std::string & host, uint16 port);

		BString Read(uint32 maxPacketSize) const;
		uint32 Write(const BString & data) const;

		uint32 Read(void * buffer, uint32 size) const;
		uint32 Write(const void * buffer, uint32 size) const;

	protected:
		ClientSocket(const ENetworkProtocol & protocol);
		ClientSocket(ISocketImplementation * socket);
};
