/*++

Copyright (c) Sydus.

Module:

    Module_Posix.h

Authors:

    Sharvil Nanavati (sharvil) 2005-10-18

--*/

#pragma once

#include "base.h"

#include <dlfcn.h>

class Module_Posix
{
	public:
		Module_Posix();
		explicit Module_Posix(const std::string & filename);
		~Module_Posix();

		void Open(const std::string & filename);
		void Close();

		template <typename T>
		bool ReadSymbol(const std::string & name, T & symbol);

	private:
		void * iHandle;
};

template <typename T>
bool Module_Posix::ReadSymbol(const std::string & name, T & symbol)
{
	if(iHandle == 0)
		return false;

	//
	// Clear out any error condition before calling dlsym.
	//
	dlerror();

	symbol = (T)dlsym(iHandle, name.c_str());

	if(dlerror() != 0)
		symbol = (T)0;

	return (symbol != (T)0);
}
