/*++

Copyright (c) Sydus.

Module:

    Thread_Posix.h

Authors:

    Sharvil Nanavati (sharvil) 2006-03-22

--*/

#pragma once

#include "base.h"
#include "IThreadImplementation.h"

#include <pthread.h>

class Thread;

class Thread_Posix : public IThreadImplementation
{
	friend class Thread;

	private:
		Thread_Posix(Thread & parent);
		~Thread_Posix();

		void Start();
		void Join();
		void Exit();

		bool IsAlive() const;

	private:
		static void * EntryPoint(void * self);
		static void ExitPoint(void * self);

		Thread & iParent;
		pthread_t iThreadHandle;
		bool iIsAlive;
};
